// Script to sanitize global symbols in Ghidra
// @category _Reman3
// @menupath Reman3.Sanitize Global Symbols
// @importpackage org.sqlite

import ghidra.app.script.GhidraScript;
import re3lib.GlobalDumper;
import re3lib.RemanConfig;
import re3lib.FunctionDatabase;

public class SanitizeGlobalSymbols extends GhidraScript {
  @Override
  public void run() throws Exception {
    RemanConfig.INSTANCE = new RemanConfig(this);
    RemanConfig.INSTANCE.createDirectories();

    try (FunctionDatabase functionDatabase = new FunctionDatabase(this)) {
      GlobalDumper globalDumper = new GlobalDumper(this, functionDatabase);

      globalDumper.sanitizeGlobalSymbols();

      globalDumper.dumpGlobals();
    }
  }
}
