#!/bin/bash
set -e
tool=build/clang-x86_64-pc-windows-msvc/Release/gh_tool
cmake --build build/clang-x86_64-pc-windows-msvc/Release --target gh_tool

types=(auto ref fix stub)
for type in "${types[@]}"; do
    file_list="files_${type}.txt"
    rm -f "$file_list"

    if [ -d "tmps/gh_${type}" ]; then
        for file in "tmps/gh_${type}"/*.cxx; do
            echo "$file" >>"$file_list"
        done
        $tool -v --log-file=log-functions.txt functions "@$file_list" --type=$type
    fi
done

$tool -v --log-file=log-globals.txt globals tmps/gh_global.h
$tool -v --log-file=log-duplicates.txt verify
